unit uVisualFrame;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes,
  Vcl.Graphics, Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, IdBaseComponent, IdComponent, IdTCPConnection,
  IdTCPClient, IdHTTP,


  HTTPApp,
  IdMultipartFormData, FireDAC.Stan.Intf, FireDAC.Stan.Option, FireDAC.Stan.Error, FireDAC.UI.Intf, FireDAC.Phys.Intf,
  FireDAC.Stan.Def, FireDAC.Stan.Pool, FireDAC.Stan.Async, FireDAC.Phys, FireDAC.VCLUI.Wait, Data.DB,
  FireDAC.Comp.Client, System.IOUtils,IdIOHandlerStack,IdIOHandlerSocket,IdIOHandler,System.RegularExpressions,
  System.Types,

  //MyUnits

  uHTTP_ConnectionParams, uHTTPRequests,uDivideAndGatherFile,uSendFileInChunks

  // IdSSL, IdSSLOpenSSL
  ;



type
  TVisualFrame_HTTP = class(TFrame)

    bSendFile: TButton;
    OpenDialog: TOpenDialog;
    IdHTTP: TIdHTTP;
    FDConnection_External: TFDConnection;
    bCreateDir: TButton;
    SendPOSTParams: TButton;
    bCreateCurrentDirOnServer: TButton;
    bCreateTempDir: TButton;
    bDeleteTempDir: TButton;
    bDivideFile: TButton;
    bTest: TButton;
    bSendManyFiles: TButton;
    GatherFile: TButton;
    bSendChunksInfo: TButton;
    bSendFileInChunks: TButton;

    procedure bSendFileClick(Sender: TObject);
    procedure bCreateDirClick(Sender: TObject);
    procedure SendPOSTParamsClick(Sender: TObject);
    procedure bCreateCurrentDirOnServerClick(Sender: TObject);
    procedure bCreateTempDirClick(Sender: TObject);
    procedure bDeleteTempDirClick(Sender: TObject);
    procedure bDivideFileClick(Sender: TObject);
    procedure bTestClick(Sender: TObject);
    procedure bSendManyFilesClick(Sender: TObject);
    procedure GatherFileClick(Sender: TObject);
    procedure bSendChunksInfoClick(Sender: TObject);
    procedure bSendFileInChunksClick(Sender: TObject);
    procedure FrameClick(Sender: TObject);


  private
    { Private declarations }

    //Fields
    FHTTP_ConnectionParams:THTTP_ConnectionParams;
    FHTTPServerToRequest:string;

    FHTTPRequests:THTTPRequests;

    //Methods


  public
    { Public declarations }



   //Fields


   //Methods

   constructor Create(AOwner: TComponent); override;
   destructor Destroy;

   procedure DefineServerToRequest;

   //properties

   property HTTP_ConnectionParams:THTTP_ConnectionParams read
   FHTTP_ConnectionParams write FHTTP_ConnectionParams;

   property HTTPServerToRequest:string read FHTTPServerToRequest
   write FHTTPServerToRequest;


   {Creates temp dir, dividing file in chunks, sending
   chunks info and then sending chunks at last checks on Server integrity}

   procedure SendFileInChunks(AFilePath:string; ChunkSize:Int64);


  end;

implementation

{$R *.dfm}

uses uCreateUniqueName;


//-------------------- Create Destroy

constructor TVisualFrame_HTTP.Create(AOwner: TComponent);
begin
  inherited;

FHTTP_ConnectionParams:=THTTP_ConnectionParams.Create(Self);
FHTTPRequests:=THTTPRequests.Create(Self);

IdHTTP.ReadTimeout:=30000;

end;

//-------------------------------------

destructor TVisualFrame_HTTP.Destroy;
begin
//FreeAndNil(FHTTP_ConnectionParams); // will be deleted automatically
end;



procedure TVisualFrame_HTTP.FrameClick(Sender: TObject);
begin

end;

//-------------------------------------

procedure TVisualFrame_HTTP.SendFileInChunks(AFilePath: string; ChunkSize:Int64);

begin

 {}


end;

//-----------------------------------------------

procedure TVisualFrame_HTTP.SendPOSTParamsClick(Sender: TObject);
begin
FHTTPRequests.SendPostParamsForTest;
end;

//-------------------------------------

procedure TVisualFrame_HTTP.DefineServerToRequest;
begin
  // Defining Server To Request
  with FHTTP_ConnectionParams do
  begin
    FHTTPServerToRequest := Protocol + '://' + Host + ':' + Port;
  end;
  //for example like http://localhost:40000
end;



//-------------------------------------


procedure TVisualFrame_HTTP.bSendChunksInfoClick(Sender: TObject);

var ChunksDir:string;

begin

ChunksDir:=ExtractFilePath(Application.ExeName)+'DividedFile';
FHTTPRequests.SendChunksInfo(ChunksDir,'',0);

end;

procedure TVisualFrame_HTTP.bSendFileClick(Sender: TObject);

var StandartServerResponse:string;
    MyServerResponse:string;

begin

if OpenDialog.Execute then
FHTTPRequests.SendOneFile(OpenDialog.FileName,'SomeDir',StandartServerResponse,MyServerResponse);

ShowMessage(StandartServerResponse+#13#10+MyServerResponse);

end;




procedure TVisualFrame_HTTP.bSendFileInChunksClick(Sender: TObject);

var SendFileInChunks:TSendFileInChunks;

begin

if OpenDialog.Execute then
 begin

 SendFileInChunks:=TSendFileInChunks.Create(Self);
 SendFileInChunks.SendFileInChunks(

     OpenDialog.FileName,
     1048576); // 1024*1024 <<<ChunkSize);


 end;




end;



procedure TVisualFrame_HTTP.bSendManyFilesClick(Sender: TObject);
var FilePathesSL:TStringList;
    FilesSDA:TStringdynArray;
    i: Integer;
    FilePath:string;

begin

FilePathesSL:=TStringList.Create;
FilesSDA:=TDirectory.GetFiles('DividedFile');
FilePath:=ExtractFilePath(Application.ExeName);

for i := 0 to High(FilesSDA) do FilePathesSL.Add(FilePath+FilesSDA[i]);
FHTTPRequests.SendManyFiles(FilePathesSL,'SomeDir');


FilePathesSL.Free;

end;

procedure TVisualFrame_HTTP.bTestClick(Sender: TObject);

var  NewFileName:string;
     msr:string;


begin


FHTTPRequests.IsFileOnServer(

'mypics{44F023A0-27E5-43F3-8ECF-F06BE01D65CD}.html',
'public\files\SomeUser_ID123\2016\11\9',
msr

);

ShowMessage(msr);


//FHTTPRequests.SendManyFiles2('DividedFile','123');



{
NewFileName:=TCreateUniqueName.CreateUniqueNameAddingGUID('VeryLongText',7);
NewFileName:=TCreateUniqueName.AddParamAndValueToName('VeryLongText','chunkNumber','SomeValue255');

ShowMessage(

TCreateUniqueName.GetParamValueFromFileName(NewFileName,'chunkNumber')

);

}

//ShowMessage(NewFileName);

//M:=RegEx.Matches( NewFileName ,'{chunkNumber=[\w\d]*}');//chunkNumber=[\w\d]*[\d]\b //chunkNumber=[\w]*[\d]\b
//if M.Count>0 then M2:=RegEx.Matches( M.Item[M.Count-1].Value ,'=[\w\d]*');
//if M2.Count>0 then M3:=RegEx.Matches( M2.Item[M2.Count-1].Value ,'[\w\d]*');




end;

procedure TVisualFrame_HTTP.bCreateCurrentDirOnServerClick(Sender: TObject);
begin
FHTTPRequests.CreateCurrentDayDirOnServer;
FHTTPRequests.CreateCurrentDayDirThumbsOnServer;
end;

procedure TVisualFrame_HTTP.bCreateDirClick(Sender: TObject);
var MyServerResponse:string;
begin
//ShowMessage(IdHTTP.Version);
FHTTPRequests.CreateDirOnServer('public\files\SomeUser_ID123\2016\11\5\temp\23',MyServerResponse);
end;



procedure TVisualFrame_HTTP.bCreateTempDirClick(Sender: TObject);
begin
FHTTPRequests.CreateTempFolderForFileChunks('SomeFileName');
end;

procedure TVisualFrame_HTTP.bDeleteTempDirClick(Sender: TObject);
begin
FHTTPRequests.DeleteTempFolderForFileChunks('SomeFileName');
end;

procedure TVisualFrame_HTTP.bDivideFileClick(Sender: TObject);
var DivideAndGatherFile:TDivideAndGatherFile;
    dirForChunks:string;

begin

 DivideAndGatherFile:=TDivideAndGatherFile.Create(Self);

 dirForChunks:=ExtractFilePath(Application.ExeName)+'DividedFile'+'\';
 if not TDirectory.Exists(dirForChunks) then TDirectory.CreateDirectory(dirForChunks);



     if OpenDialog.Execute then begin


         DivideAndGatherFile.DivideFileInChunks(

         OpenDialog.FileName,

         1048576, // 1024*1024 <<<ChunkSize

         dirForChunks

         );



     end;



end;



procedure TVisualFrame_HTTP.GatherFileClick(Sender: TObject);

var DivideAndGatherFile:TDivideAndGatherFile;

    ChunksDir:string;

begin


  ChunksDir:=ExtractFilePath(Application.ExeName)+'DividedFile'+'\';


  DivideAndGatherFile:=TDivideAndGatherFile.Create(Self);

  DivideAndGatherFile.GatherFileFromChunks(

  ChunksDir,

  'GatheredFile',

  'GatheredFile.txt'



  );


end;


end.
