unit uHTTPServer_Main;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, IdBaseComponent, IdComponent, IdCustomTCPServer, IdCustomHTTPServer,
  IdHTTPServer, Vcl.StdCtrls,

  HTTPApp,
  IdMultipartFormData, IdContext, System.IOUtils,
  IdServerIOHandler, IdSSL, IdSSLOpenSSL, IdSSLOpenSSLHeaders, System.json,
  Contnrs,System.NetEncoding,

  //myUnits
  uDecodePOstRequest,uHTTPServerCommandGet, Vcl.ExtCtrls, IdIPWatch
  ;



type
  TfHTTPServer = class(TForm)
    bToggleStartStopServer: TButton;
    IdHTTPServer: TIdHTTPServer;
    mmo1: TMemo;
    mmo2: TMemo;
    mmo3: TMemo;
    IdServerIOHandlerSSLOpenSSL: TIdServerIOHandlerSSLOpenSSL;
    lServer: TLabel;
    eServer: TEdit;
    eProtocol: TEdit;
    lProtocol: TLabel;
    lPort: TLabel;
    ePort: TEdit;
    bTest: TButton;
    TrayIcon: TTrayIcon;
    IdIPWatch: TIdIPWatch;
    procedure bToggleStartStopServerClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure IdHTTPServerCommandGet(AContext: TIdContext; ARequestInfo: TIdHTTPRequestInfo;
      AResponseInfo: TIdHTTPResponseInfo);
    procedure IdServerIOHandlerSSLOpenSSLGetPassword(var Password: string);
    procedure FormDestroy(Sender: TObject);
    procedure IdServerIOHandlerSSLOpenSSLStatus(ASender: TObject; const AStatus: TIdStatus; const AStatusText: string);
    procedure IdServerIOHandlerSSLOpenSSLStatusInfo(const AMsg: string);
    procedure IdServerIOHandlerSSLOpenSSLStatusInfoEx(ASender: TObject; const AsslSocket: PSSL; const AWhere,
      Aret: Integer; const AType, AMsg: string);
    procedure TrayIconClick(Sender: TObject);
    procedure bTestClick(Sender: TObject);
  private

    FIsListening:Boolean;

    FHTTPServerCommandGet:THTTPServerCommandGet;



  public
    { Public declarations }
  end;

var
  fHTTPServer: TfHTTPServer;

implementation

{$R *.dfm}






procedure TfHTTPServer.bTestClick(Sender: TObject);

var JSONObject: TJSONObject;
    jsonArray:TJSONArray;

    JSONObjectAfter:TJSONObject;

    OL:TObjectLIst;

  s: string;
  i: Integer;
  RussianWords: string;

begin


 ShowMessage(

   IdHTTPServer.Version

 );


{
// RussianWords:=TNetEncoding.URL.Encode(' ');

 RussianWords:=TNetEncoding.URL.Decode(' ');

 ShowMessage(

  //  RussianWords+#13#10+
    TNetEncoding.URL.Decode(RussianWords)

 );
}
end;

procedure TfHTTPServer.bToggleStartStopServerClick(Sender: TObject);
begin

//if FIsListening then

if IdHTTPServer.Active then
    begin

    Self.Caption:=Self.Name+' Server Stopped';
    bToggleStartStopServer.Caption:='Start Server';

    idHTTPServer.Active:=false;
    //FIsListening:=false;
    idHTTPServer.StopListening;

    idHTTPServer.Bindings.Clear;

    end else

    begin

    Self.Caption:=Self.Name+' Server Started';
    bToggleStartStopServer.Caption:='Stop Server';

    //idHTTPServer.StartListening;
    idHTTPServer.Active:=true;
    //FIsListening:=True;

    end;


end;


//------------------------------------CREATE DESTROY------------

procedure TfHTTPServer.FormCreate(Sender: TObject);
begin


ReportMemoryLeaksOnShutdown:=true;

  idHTTPServer.DefaultPort := 40000;
  idHTTPServer.Active := false;

// Activating Server Here
bToggleStartStopServer.Click;
FIsListening:=true;

//IdHTTPServer.Bindings.Add.Port := 80;
//IdHTTPServer.Bindings.Add.Port := 443;
IdHTTPServer.Bindings.Add.Port := 40000;


FHTTPServerCommandGet:=THTTPServerCommandGet.Create(Self);
//eServer.Text:=IdIPWatch.LocalIP;



end;



procedure TfHTTPServer.FormDestroy(Sender: TObject);
begin
IdHTTPServer.Active:=false; // To Prevent memory leaks
end;




procedure TfHTTPServer.IdHTTPServerCommandGet(AContext: TIdContext; ARequestInfo: TIdHTTPRequestInfo;
  AResponseInfo: TIdHTTPResponseInfo);


var DecodePostRequest:TDecodePostRequest;
    PostParams:TStringList;
    dir: string;

    ChunksInfo:string;

       DecodedParam:string;
  EncodedParamValue: string;

  AppPath:string;
  filepath: string;
  WebPageContent: string;
  IsWebPage: Boolean;

begin

  if ARequestInfo.URI='/testConnection' then

  begin
//  AResponseInfo.ContentText := 'ok';
     AResponseInfo.ResponseNo := 200;
     AResponseInfo.WriteContent;

  end else
//
//  if ARequestInfo.URI='//' then AResponseInfo.ResponseNo := 200;


  if ARequestInfo.URI=('/sendfile') then
  FHTTPServerCommandGet.ReceiveFile(AContext,ARequestInfo,AResponseInfo) else


if ARequestInfo.URI=('/CreateDirOnServer') then
FHTTPServerCommandGet.CreateDirOnServer(AContext,ARequestInfo,AResponseInfo) else

if ARequestInfo.URI=('/DeleteDirOnServer') then
FHTTPServerCommandGet.DeleteDirOnServer(AContext,ARequestInfo,AResponseInfo) else

if ARequestInfo.URI=('/DeleteFileOnServer') then
FHTTPServerCommandGet.DeleteFileOnServer(AContext,ARequestInfo,AResponseInfo) else


if ARequestInfo.URI=('/SendChunksInfo') then
FHTTPServerCommandGet.ReceiveChunksInfo(AContext,ARequestInfo,AResponseInfo,ChunksInfo) else


if ARequestInfo.URI=('/GatherFileFromChunks') then
FHTTPServerCommandGet.GatherFileFromChunks(AContext,ARequestInfo,AResponseInfo) else

if ARequestInfo.URI=('/checkChunksIntegrity') then
FHTTPServerCommandGet.CheckChunksIntegrity(AContext,ARequestInfo,AResponseInfo) else

if ARequestInfo.URI=('/isfileonserver') then
FHTTPServerCommandGet.IsFileOnServer(AContext,ARequestInfo,AResponseInfo) else



if ARequestInfo.URI=('/SomeURICommand') then

   begin

   PostParams:=TStringList.Create;
   PostParams.Clear;
   DecodePostRequest:=TDecodePostRequest.Create(Self);
   DecodePostRequest.DecodePostParamsAnsi(AContext,ARequestInfo,AResponseInfo,PostParams);
   FreeAndNil(DecodePostRequest);



 //  EncodedParamValue:=PostParams.Values['SomePOSTParam1'];

//   EncodedParamValue:=StringReplace(EncodedParamValue,'='#$D#$A'','',[rfReplaceAll]);




//   DecodedParam:=TNetEncoding.URL.Decode(EncodedParamValue);



   ShowMessage(

 //  'SomePOSTParam1='+DecodedParam+

   PostParams.Values['SomePOSTParam1']+

   #13#10+

      'SomePOSTParam2='+

      (PostParams.Values['SomePOSTParam2'])


   );


   FreeAndNil(PostParams);

   end else


    //Preparing file for download if it is on the Server

    begin

//     ShowMessage(

//     ARequestInfo.URI
     //ARequestInfo.Host
     //ARequestInfo.Document

//     );

    if FHTTPServerCommandGet.IsFileOnServerByURI(ARequestInfo.URI,filepath,IsWebPage,WebPageContent) then

     begin

       AResponseInfo.ResponseNo := 200;

       if IsWebPage then
       AResponseInfo.ContentText:=WebPageContent else
       AResponseInfo.ServeFile(AContext, filepath);


     end else


     AresponseInfo.ResponseNo := 404;

    end;


end;


procedure TfHTTPServer.IdServerIOHandlerSSLOpenSSLGetPassword(var Password: string);
begin
Password:='123';
end;

procedure TfHTTPServer.IdServerIOHandlerSSLOpenSSLStatus(ASender: TObject; const AStatus: TIdStatus;
  const AStatusText: string);
begin

if not TFile.Exists('Log.txt') then TFile.Create('Log.txt');


TFile.AppendAllText('Log.txt',' '+AStatusText);


end;

procedure TfHTTPServer.IdServerIOHandlerSSLOpenSSLStatusInfo(const AMsg: string);
begin


if not TFile.Exists('Log.txt') then TFile.Create('Log.txt');


TFile.AppendAllText('Log.txt',' '+AMsg);


end;

procedure TfHTTPServer.IdServerIOHandlerSSLOpenSSLStatusInfoEx(ASender: TObject; const AsslSocket: PSSL; const AWhere,
  Aret: Integer; const AType, AMsg: string);
begin

if not TFile.Exists('Log.txt') then TFile.Create('Log.txt');


TFile.AppendAllText('Log.txt',' '+AMsg);


end;

procedure TfHTTPServer.TrayIconClick(Sender: TObject);
begin

  TrayIcon.Visible := False;
  Application.MainForm.Show;


end;

//-----------------------------------------------------------






end.
